=== debian/changelog ===
activiz.net (1:1.0~git20111123-6) unstable; urgency=low

  * Installing into the gac.
  * Remove DMUA flag, not required anymore
  * Bump Std-Vers to 3.9.3, no changes needed
  * Use my @d.o alias

 -- Mathieu Malaterre <malat@debian.org>  Sat, 21 Apr 2012 22:39:10 +0200

activiz.net (1:1.0~git20111123-5) unstable; urgency=low

  * discard result from build-indep target from d/rules.

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 01 Feb 2012 14:09:16 +0100

activiz.net (1:1.0~git20111123-4) unstable; urgency=medium

  * Work around bbuild and build-indep, by hidding doxygen target.

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Tue, 31 Jan 2012 17:54:55 +0100

activiz.net (1:1.0~git20111123-3) unstable; urgency=medium

  * Speed up compilation of build-indep target (dot generation)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Sat, 28 Jan 2012 15:32:09 +0100

activiz.net (1:1.0~git20111123-2) unstable; urgency=medium

  * Use debian default csharp compiler. Closes: #655935

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Tue, 17 Jan 2012 10:17:22 +0100

activiz.net (1:1.0~git20111123-1) unstable; urgency=low

  [ Thorsten Alteholz ]
  * debian/get-orig-source: put orig.tar.gz in ../tarballs to allow
    automatic build with svn-buildpackage

  [ Mathieu Malaterre ]
  * Fix compilation issue with VTK 5.8.0
  * Automatically computes soversion information from vtk version

  [ Andreas Tille ]
  * debian/copyright: Fixed License paragraphs to match DEP5
  * debian/control: Added myself as uploader

 -- Andreas Tille <tille@debian.org>  Thu, 24 Nov 2011 09:57:56 +0100

activiz.net (5.6.1-3) unstable; urgency=low

  * Need doxygen-latex to pull dvips/latex dependency.
  * Use trick to conditionnaly set GENERATE_DOXYGEN. Closes: #648074

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Thu, 10 Nov 2011 22:22:20 +0100

activiz.net (5.6.1-2) unstable; urgency=low

  * Fix issue on buildd machine where doxygen would not be available

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 09 Nov 2011 10:23:06 +0100

activiz.net (5.6.1-1) unstable; urgency=low

  * Initial release (Closes: #611764)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Mon, 31 Oct 2011 15:44:31 +0100
