=== debian/changelog ===
activiz.net (1:1.0~git20111214-3build1) wily; urgency=medium

  * No-change rebuild against libvtk5.10.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 26 Sep 2015 07:34:20 +0200

activiz.net (1:1.0~git20111214-3) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Remove Mathieu Malaterre from Uploaders as requested
  * Add Corentin Desfarges to Uploaders as requested
  * Moved from SVN to Git
  * cme fix dpkg-control
  * debian/get-orig-source: use xz compressed tarball
  * debian/watch: Document why there is no proper watch file

  [ Mathieu Malaterre ]
  * debian/patches/vtk5_10_1.patch: fix compilation against vtk5.10
    (Closes: #798545)

 -- Andreas Tille <tille@debian.org>  Wed, 08 Jul 2015 15:49:50 +0200

activiz.net (1:1.0~git20111214-2) unstable; urgency=low

  * Add missing .doc-base file. Closes: #703333
  * Remove .dot file from doc package
  * Do not compress .map file from HTML files

 -- Mathieu Malaterre <malat@debian.org>  Mon, 01 Apr 2013 09:32:09 +0200

activiz.net (1:1.0~git20111214-1) unstable; urgency=low

  * New upstream
  * Bump Std-Vers to 3.9.4, no changes needed
  * Use dh(9), get hardening for free
  * Update patches (use DEP3)
  * Remove SONAME from C# gluelib. Closes: #673966

 -- Mathieu Malaterre <malat@debian.org>  Fri, 15 Mar 2013 15:06:20 +0100
