=== debian/watch ===
# Upstream only provides a Git repository but no tarball
# This no watch file is possible
